100 REM ---- BMPDITH.BAS
110 REM ---- Load a 16 color BMP and display using 4-pixel dithering
120 REM ---- Dithering will display as 16 colors in CGA composite mode
130 REM ---- Note: program assumes .BMP uses CGA composite palette
140 REM ---- by BdR - bas.de.reuver@home.nl
150 FILENAME$ = "-"
160 WHILE (FILENAME$ <> "")
170   CLS
180   FILES "*.BMP"
190   INPUT "Enter filename to load:", FILENAME$
200   IF (FILENAME$ <> "") AND (RIGHT$(FILENAME$, 4) <> ".BMP") THEN FILENAME$ = FILENAME$ + ".BMP"
210   IF (FILENAME$ <> "") THEN GOSUB 250: REM load and display .BMP image
220   IF (FILENAME$ <> "") THEN GOSUB 710: REM wait for keypress
230 WEND
240 END: REM -- end of program
250 REM -----------------------------------
260 REM ---- load .BMP file subroutine ----
270 REM -----------------------------------
280 REM known bug: image not loaded properly when (XSIZEBMP MOD 4) <> 0
290 SCREEN 2: KEY OFF: CLS
300 B = 0
310 IPOS = 0
320 OPEN "I", 1, FILENAME$
330 REM ---- check file header ----
340 FOR I = 0 TO 117
350   B = ASC(INPUT$(1,#1))
360   IF (IPOS = 0) AND (B <> 66) THEN GOTO 790: REM no header "B"
370   IF (IPOS = 1) AND (B <> 77) THEN GOTO 790: REM no header "M"
380   IF (IPOS = 18) THEN XSIZEBMP = B
390   IF (IPOS = 19) THEN XSIZEBMP = XSIZEBMP + (B * 256)
400   IF (IPOS = 22) THEN YSIZEBMP = B
410   IF (IPOS = 23) THEN YSIZEBMP = YSIZEBMP + (B * 256)
420   IF (IPOS = 28) AND (B <> 4)  THEN GOTO 810: REM not 4 bits, 16 color
430   IPOS = IPOS + 1
440 NEXT I
450 REM ---- pixels in .BMP are stored from bottom right to top left ----
460 XPOS = 0
470 YPOS = YSIZEBMP - 1
480 WHILE (EOF(1) = 0)
490   B = ASC(INPUT$(1,#1))
500   PIXEL = INT(B/16)
510   GOSUB 570: REM draw pixel
520   PIXEL = B AND 15
530   GOSUB 570: REM draw pixel
540 WEND
550 CLOSE #1
560 RETURN
570 REM -------------------------------
580 REM ---- draw pixel subroutine ----
590 REM -------------------------------
600 REM PRINT PIXEL, "-", XPOS, ",", YPOS
610 IF ((PIXEL AND 1) <> 0) THEN PSET((XPOS * 4)+0, YPOS)
620 IF ((PIXEL AND 2) <> 0) THEN PSET((XPOS * 4)+1, YPOS)
630 IF ((PIXEL AND 4) <> 0) THEN PSET((XPOS * 4)+2, YPOS)
640 IF ((PIXEL AND 8) <> 0) THEN PSET((XPOS * 4)+3, YPOS)
650 XPOS = (XPOS + 1) MOD XSIZEBMP
660 IF (XPOS = 0) THEN YPOS = YPOS - 1
670 RETURN
680 REM ------------------------------------
690 REM -- wait for keypress subroutine ----
700 REM ------------------------------------
710 WAITKEY$ = ""
720 WHILE (WAITKEY$ = "")
730   WAITKEY$ = INKEY$
740 WEND
750 RETURN
760 REM -----------------
770 REM ---- errors  ----
780 REM -----------------
790 PRINT "Not a bitmap file, error reading header, ", FILENAME$
800 END
810 PRINT "Not a 16 color bitmap file, ", FILENAME$, ", expected 4 found ", B
820 END
